/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - September 25, 2002 (new file, copied from multiviewsTabs.js).
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -  David Perry <d.perry@utoronto.ca>
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU General Public License Version 2 or later (the
   - "GPL"), in which case the provisions of the GPL are applicable
   - instead of those above.  If you wish to allow use of your
   - version of this file only under the terms of the GPL and not to
   - allow others to use your version of this file under the MPL,
   - indicate your decision by deleting the provisions above and
   - replace them with the notice and other provisions required by
   - the GPL.  If you do not delete the provisions above, a recipient
   - may use your version of this file under either the MPL or the
   - GPL.
   -
*/

var tabIndex; // added for functions: 
              // loadFolderAsGroup(aFolder);
              // OpenBookmarkFolder(element, datasource, tabCount, tabOpen);
              // OpenBookmarkFolderFromResource(rdf, datasource, resource, tabCount, tabOpen);

////////////////////////////////////////////////////////////////////////////////
// this function hides the first two menuitems, and removes all bookmark items
////////////////////////////////////////////////////////////////////////////////
function cleanupForTabGroups(aFolder)
{
  var children = aFolder.childNodes;
  var type;
  // itterate over all menu items
  for ( var i = 0; i < children.length; i++ ) {
    if ( children[ i ].getAttribute( "folder" ) ) {
      // we found a bookmark folder so get rid of the bookmark items
      for ( i = 0; i < children.length; i++ ) {
        if ( children[ i ].getAttribute( "item" ) )
          aFolder.removeChild( children[ i ] );
      }
      // hide 'Open This Folder As Group' and the corresponding separator
      if ( !children[ 0 ].getAttribute( "hidden" ) ) {
        children[ 0 ].setAttribute( "hidden", "true" );
        children[ 1 ].setAttribute( "hidden", "true" );
      }
      break;
    }
  }
}
////////////////////////////////////////////////////////////////////////////////
// this function loads the selected Bookmark Folder as group
////////////////////////////////////////////////////////////////////////////////
function loadFolderAsGroup(aFolder, aNewWindowFlag)
{
  var children = aFolder.childNodes;
  var newTabs = readMyPref( "multizilla.newtabfor.groupfolders", "bool", false );
  var newWindows = aNewWindowFlag;
  var tabPanels = getBrowser().mPanelContainer.childNodes;
  var tabCount = tabPanels.length;
  var startTab = newTabs ? tabCount : 0;
  var url;
  tabIndex = 0;
  // itterate over all menu items but skip the first two
  // [0] is 'Open This Folder as Group' and [1] is the menu separator
  // I might need to change this text
  for (var i = 2; i < children.length; i++) {
    url = children[i].getAttribute("url");
    if (children[i].getAttribute("container") == "true") {
      OpenBookmarkFolder(children[i], document.getElementById('BookmarksMenu').database, tabCount, newTabs, newWindows, true);
    }
    else if (url) {
      if (newWindows) {
        window.open(url);
      } 
      else {
        if (!newTabs && tabIndex < tabCount)
          tabPanels[tabIndex].loadURI(url, null, nsIWebNavigation.LOAD_FLAGS_NONE);
        else
          getBrowser().addTab(url);
        tabIndex++;
      }
    }
  }
  // Select the first tab in the group.
  if (!newWindows)
    gBrowser.selectedTab = gBrowser.mTabContainer.childNodes[startTab];
  // Close remaining tabs in case we are using existing tabs.
  // We might even add a new pref setting for this behavior.
  if (!newTabs && !newWindows) {
    for (i = tabCount-1; i >= tabIndex; i--)
      gBrowser.removeTab(gBrowser.mTabContainer.childNodes[i]);
  }
}
////////////////////////////////////////////////////////////////////////////////
// this function opens a bookmark folder, it is a modified copy of
// OpenBookmarkGroup(element, datasource) in navigator.js
////////////////////////////////////////////////////////////////////////////////
function OpenBookmarkFolder(element, datasource, tabCount, newTabs, newWindows, isChild)
{
  if (!datasource)
    return;
  var id = element.getAttribute("id");
  var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                      .getService(Components.interfaces.nsIRDFService);
  var resource = rdf.GetResource(id, true);
  OpenBookmarkFolderFromResource(rdf, datasource, resource, tabCount, newTabs, newWindows, isChild);
}
////////////////////////////////////////////////////////////////////////////////
// this function opens nested bookmark folders in a new tabs, it is a modified 
// copy of OpenBookmarkGroupFromResource(element, datasource) in navigator.js
////////////////////////////////////////////////////////////////////////////////
function OpenBookmarkFolderFromResource(rdf, datasource, resource, tabCount, newTabs, newWindows, isChild)
{
  var urlResource = rdf.GetResource("http://home.netscape.com/NC-rdf#URL");
  var rdfContainer = Components.classes["@mozilla.org/rdf/container;1"]
                               .getService(Components.interfaces.nsIRDFContainer);
  rdfContainer.Init(datasource, resource);
  var containerChildren = rdfContainer.GetElements();
  var tabPanels = gBrowser.mPanelContainer.childNodes;
  var tabIndex = 0;

  while (containerChildren.hasMoreElements()) {
    resource = containerChildren.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    var target = datasource.GetTarget(resource, urlResource, true);
    if (target) {
      var uri = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;

      if (newWindows) {
        window.open(uri);
      } 
      else {
        if (!isChild && !newTabs && tabIndex < tabCount)
          tabPanels[tabIndex].loadURI(uri, null, nsIWebNavigation.LOAD_FLAGS_NONE);
        else
          gBrowser.addTab(uri);
        tabIndex++;
      }
    }
    else OpenBookmarkFolderFromResource(rdf, datasource, resource, tabCount, newTabs, newWindows, isChild);
  }
}
////////////////////////////////////////////////////////////////////////////////
// this function loads a mozilla GroupMark (tab startup group)
////////////////////////////////////////////////////////////////////////////////
function OpenBookmarkGroupAtStartup()
{
  // var id = pref.getComplexValue("browser.tabs.groupmark", Components.interfaces.nsISupportsWString).data;
  // id = pref.getComplexValue("browser.tabs.groupmark", Components.interfaces.nsISupportsString).data;
  id = readMyPref("browser.tabs.groupmark", "string", null );
  if (!id)
    return;
  var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                      .getService(Components.interfaces.nsIRDFService);
  var resource = rdf.GetResource(id, true);
  OpenBookmarkGroupFromResource(resource, document.getElementById('BookmarksMenu').database, rdf);
}
////////////////////////////////////////////////////////////////////////////////
// this function writes two pref settings for the startup Groupmark
////////////////////////////////////////////////////////////////////////////////
function setStartupGroupmark(bookmarkID)
{
  writePref("string", "multizilla.tabs.groupmark", bookmarkID);
  writePref("int", "browser.startup.page", 3);
}
////////////////////////////////////////////////////////////////////////////////
// this function writes two pref settings for the home page
////////////////////////////////////////////////////////////////////////////////
function setStartupBookmark(url)
{
  writePref("string", "browser.startup.homepage", url);
  writePref("int", "browser.startup.page", 1);
}
////////////////////////////////////////////////////////////////////////////////
// this function reads a pref and hides deselected menu items from the popup
////////////////////////////////////////////////////////////////////////////////
function refreshBookmarkMenuPopup(aParent, aPrefIdentifier)
{
  if (!aParent || !aPrefIdentifier)
    return;
  var menu = aParent;
  var menuItems = menu.childNodes.length;
  var prefValue = Number(readMyPref(aPrefIdentifier, "int", 0));
  /* the extra menu items for the menupopup are:
  - (Empty) 
    note: this menu item is not used for bookmark items
  - Open this [Bookmark/Folder/Groupmark] in Tabs
  - Open this [Bookmark/Folder/Groupmark] in Windows
  - Use this [Bookmark/Folder/Groupmark] as Home Page
  - menuseparator
    note: this menu item is not used for bookmark items
  */
  if (aPrefIdentifier == "multizilla.bookmark.items") {
    menu.childNodes[0].setAttribute("hidden", (prefValue & 1) ? "false" : "true");
    menu.childNodes[1].setAttribute("hidden", (prefValue & 2) ? "false" : "true");
    menu.childNodes[2].setAttribute("hidden", (prefValue & 4) ? "false" : "true");
  }
  else if (menuItems > 5) {
    menu.firstChild.setAttribute('hidden', 'true');
    menu.childNodes[1].setAttribute("hidden", (prefValue & 1) ? "false" : "true");
    menu.childNodes[2].setAttribute("hidden", (prefValue & 2) ? "false" : "true");
    menu.childNodes[3].setAttribute("hidden", (prefValue & 4) ? "false" : "true");
    menu.childNodes[4].setAttribute("hidden", (prefValue & 7) ? "false" : "true");
  }
  if (menuItems == 5 || menuItems == 6 && menu.childNodes[5].localName == "menuitem") {
    menu.childNodes[1].setAttribute("hidden", "true");
    menu.childNodes[2].setAttribute("hidden", "true");
    menu.childNodes[3].setAttribute("hidden", "true");
    menu.childNodes[4].setAttribute("hidden", "true");
  }
}
////////////////////////////////////////////////////////////////////////////////
// this function initializes the bookmarks template by disabling (a) rule(s)
////////////////////////////////////////////////////////////////////////////////
function initializeBookmarksTemplate()
{
  var mzPlainItem  = document.getElementById('mzPlainItem');
  var mzPlainFolder = document.getElementById('mzPlainFolder');
  var mzPlainGroup = document.getElementById('mzPlainGroup');

  if (!mzPlainItem || !mzPlainFolder || !mzPlainGroup)
    return; // this should never happen, but just in case ;)

  if (readMyPref("multizilla.bookmark.items", "int", 0))
    mzPlainItem.setAttribute("disabled", "true");
  if (readMyPref("multizilla.bookmark.folders", "int", 0))
    mzPlainFolder.setAttribute("disabled", "true");
  if (readMyPref("multizilla.bookmark.groups", "int", 0))
    mzPlainGroup.setAttribute("disabled", "true");
}
////////////////////////////////////////////////////////////////////////////////
// this function initializes the PT bookmarks template by disabling (a) rule(s)
////////////////////////////////////////////////////////////////////////////////
function initializePersonalToolbarTemplate()
{
  var mzPTPlainItem  = document.getElementById('mzPTPlainItem');
  var mzPTPlainFolder = document.getElementById('mzPTPlainFolder');
  var mzPTPlainGroup = document.getElementById('mzPTPlainGroup');
  var mzPTBPlainFolder = document.getElementById('mzPTBPlainFolder');
  var mzPTBPlainGroup = document.getElementById('mzPTBPlainGroup');

  if (!mzPTPlainItem || !mzPTPlainFolder || !mzPTPlainGroup || !mzPTBPlainFolder || !mzPTBPlainGroup)
    return; // this should never happen, but just in case ;)

  if (readMyPref("multizilla.bookmark.items", "int", 0))
    mzPTPlainItem.setAttribute("disabled", "true");
  if (readMyPref("multizilla.bookmark.folders", "int", 0)) {
    mzPTPlainFolder.setAttribute("disabled", "true");
    mzPTBPlainFolder.setAttribute("disabled", "true");
  }
  if (readMyPref("multizilla.bookmark.groups", "int", 0)) {
    mzPTPlainGroup.setAttribute("disabled", "true");
    mzPTBPlainGroup.setAttribute("disabled", "true");
  }
}